// SPDX-License-Identifier: Apache-2.0
import { createMock } from "@golevelup/ts-jest";
import { ErrorMsgFixture, EvmAddressPropsFixture, TransactionIdFixture } from "../../../../../../../../__tests__/fixtures/shared/DataFixture";
import { ErrorCode } from "../../../../../../../core/error/BaseError";
import EvmAddress from "../../../../../../../domain/context/contract/EvmAddress";
import { SecurityRole } from "../../../../../../../domain/context/security/SecurityRole";
import { AccountPropsFixture } from "../../../../../../../../__tests__/fixtures/account/AccountFixture";
import Account from "../../../../../../../domain/context/account/Account";
import { RemoveAgentCommandFixture } from "../../../../../../../../__tests__/fixtures/agent/AgentFixture";
import { RemoveAgentCommandHandler } from "./RemoveAgentCommandHandler";
import { RemoveAgentCommandResponse } from "./RemoveAgentCommand";
import { RemoveAgentCommandError } from "./error/RemoveAgentCommandError";
describe("RemoveAgentCommandHandler", () => {
    let handler;
    let command;
    const transactionServiceMock = createMock();
    const validationServiceMock = createMock();
    const accountServiceMock = createMock();
    const contractServiceMock = createMock();
    const evmAddress = new EvmAddress(EvmAddressPropsFixture.create().value);
    const transactionId = TransactionIdFixture.create().id;
    const errorMsg = ErrorMsgFixture.create().msg;
    const account = new Account(AccountPropsFixture.create());
    beforeEach(() => {
        handler = new RemoveAgentCommandHandler(accountServiceMock, transactionServiceMock, validationServiceMock, contractServiceMock);
        command = RemoveAgentCommandFixture.create();
    });
    afterEach(() => {
        jest.resetAllMocks();
    });
    describe("execute", () => {
        describe("error cases", () => {
            it("throws RemoveAgentCommandError when command fails with uncaught error", async () => {
                const fakeError = new Error(errorMsg);
                accountServiceMock.getAccountEvmAddress.mockRejectedValue(fakeError);
                const resultPromise = handler.execute(command);
                await expect(resultPromise).rejects.toBeInstanceOf(RemoveAgentCommandError);
                await expect(resultPromise).rejects.toMatchObject({
                    message: expect.stringContaining(`An error occurred while removing agent: ${errorMsg}`),
                    errorCode: ErrorCode.UncaughtCommandError,
                });
            });
        });
        describe("success cases", () => {
            it("should successfully remove agent", async () => {
                accountServiceMock.getAccountEvmAddress.mockResolvedValue(evmAddress);
                accountServiceMock.getCurrentAccount.mockReturnValue(account);
                contractServiceMock.getContractEvmAddress.mockResolvedValue(evmAddress);
                transactionServiceMock.getHandler().removeAgent.mockResolvedValue({
                    id: transactionId,
                });
                const result = await handler.execute(command);
                expect(result).toBeInstanceOf(RemoveAgentCommandResponse);
                expect(result.payload).toBe(true);
                expect(result.transactionId).toBe(transactionId);
                expect(contractServiceMock.getContractEvmAddress).toHaveBeenCalledTimes(1);
                expect(contractServiceMock.getContractEvmAddress).toHaveBeenNthCalledWith(1, command.securityId);
                expect(accountServiceMock.getAccountEvmAddress).toHaveBeenCalledTimes(1);
                expect(accountServiceMock.getAccountEvmAddress).toHaveBeenNthCalledWith(1, command.agentId);
                expect(validationServiceMock.checkPause).toHaveBeenCalledTimes(1);
                expect(validationServiceMock.checkPause).toHaveBeenCalledWith(command.securityId);
                expect(validationServiceMock.checkRole).toHaveBeenCalledTimes(1);
                expect(validationServiceMock.checkRole).toHaveBeenCalledWith(SecurityRole._DEFAULT_ADMIN_ROLE, account.id.toString(), command.securityId);
                expect(transactionServiceMock.getHandler().removeAgent).toHaveBeenCalledTimes(1);
                expect(transactionServiceMock.getHandler().removeAgent).toHaveBeenCalledWith(evmAddress, evmAddress, command.securityId);
            });
        });
    });
});
